Library Dll1;

Uses
   SysUtils,
   Classes;

Const
     Comprimento_Gol               =      100; { Milmetros (rea interna do gol) }
     Comprimento_Campo             =     1300; { Milmetros }
     Largura_Campo                 =      900; { Milmetros }
     Velocidade_Linear_Limite      =     5000; { Milmetros/s }
     Velocidade_Linear_Re_Limite   =    -5000; { Milmetros/s }
     Total_Robos_por_Equipe        =        3;
     Raio_Bola                     =       20;
     Lado_Robo                     =       75;

Type
   TGraus       = 0..360   ;
   TComprimento = -Comprimento_Gol..(Comprimento_Campo + Comprimento_Gol);
   TLargura     = 0..Largura_Campo                                       ;
   TVelocidade  = Velocidade_Linear_Re_Limite..Velocidade_Linear_Limite  ;

   TOcorrencia = (Inicio_Jogo  ,
                  Reinicio_Jogo,
                  Gol_E1       ,
                  Gol_E2       ,
                  Falta_E1     ,
                  Falta_E2     ,
                  Penalti_E1   ,
                  Penalti_E2   ,
                  TiroMeta_E1  ,
                  TiroMeta_E2  ,
                  Bola_Alto_P  ,
                  Bola_Alto_Q  ,
                  Bola_Alto_R  ,
                  Bola_Alto_S  ,
                  Jogo_em_Andamento,
                  Pausa_Simulador  );

   TPosicao = Record
      X: TComprimento;
      Y: TLargura    ;
   End;

   TInformacoes_Robo = Record
      Angulo : TGraus     ;
      Veloc  : TVelocidade;
      Posicao: TPosicao   ;
   End;

   TInformacoes_Robos = Array [1..Total_Robos_por_Equipe] of TInformacoes_Robo;

   TInformacoes_Bola = Record
      Angulo : TGraus     ;
      Veloc  : TVelocidade;
      Posicao: TPosicao   ;
   End;

Procedure Acoes_Robos (Var Estrategia_Robos_E1    : TInformacoes_Robos;
                           Informacoes_Robos_E1   : TInformacoes_Robos;
                           Informacoes_Robos_E2   : TInformacoes_Robos;
                           Informacoes_Bola       : TInformacoes_Bola ;
                           Ocorrencia             : TOcorrencia);

  Begin
  Case Ocorrencia Of

    Inicio_Jogo:
    Begin

      Estrategia_Robos_E1 [1].Posicao.X := -45;
      Estrategia_Robos_E1 [1].Posicao.Y := 383;
      Estrategia_Robos_E1 [1].Angulo    := 325;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 500;
      Estrategia_Robos_E1 [2].Posicao.Y := 600;
      Estrategia_Robos_E1 [2].Angulo    := 325;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 275;
      Estrategia_Robos_E1 [3].Posicao.Y := 250;
      Estrategia_Robos_E1 [3].Angulo    := 10;
      Estrategia_Robos_E1 [3].Veloc     := 0;


    End;
    Gol_E1:
    Begin
      Estrategia_Robos_E1 [1].Posicao.X := -45;
      Estrategia_Robos_E1 [1].Posicao.Y := 383;
      Estrategia_Robos_E1 [1].Angulo    := 325;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 400;
      Estrategia_Robos_E1 [2].Posicao.Y := 600;
      Estrategia_Robos_E1 [2].Angulo    := 325;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 275;
      Estrategia_Robos_E1 [3].Posicao.Y := 250;
      Estrategia_Robos_E1 [3].Angulo    := 10;
      Estrategia_Robos_E1 [3].Veloc     := 0;



    End;
    Gol_E2:
    Begin
      Estrategia_Robos_E1 [1].Posicao.X := -45;
      Estrategia_Robos_E1 [1].Posicao.Y := 383;
      Estrategia_Robos_E1 [1].Angulo    := 325;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 400;
      Estrategia_Robos_E1 [2].Posicao.Y := 600;
      Estrategia_Robos_E1 [2].Angulo    := 325;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 300;
      Estrategia_Robos_E1 [3].Posicao.Y := 250;
      Estrategia_Robos_E1 [3].Angulo    := 10;
      Estrategia_Robos_E1 [3].Veloc     := 0;


    End;
    Jogo_em_Andamento:

    Begin


      Estrategia_Robos_E1 [2].Veloc := 150;
      Estrategia_Robos_E1 [3].Veloc := 200;

    End;
    Falta_E1:
    Begin
      Estrategia_Robos_E1 [1].Posicao.X := -45;
      Estrategia_Robos_E1 [1].Posicao.Y := 383;
      Estrategia_Robos_E1 [1].Angulo    := 0;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 700;
      Estrategia_Robos_E1 [2].Posicao.Y := 450;
      Estrategia_Robos_E1 [2].Angulo    := 0;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 700;
      Estrategia_Robos_E1 [3].Posicao.Y := 650;
      Estrategia_Robos_E1 [3].Angulo    := 0;
      Estrategia_Robos_E1 [3].Veloc     := 0;
    End;
    Falta_E2:
    Begin
      Estrategia_Robos_E1 [1].Posicao.X := -45;
      Estrategia_Robos_E1 [1].Posicao.Y := 383;
      Estrategia_Robos_E1 [1].Angulo    := 0;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 200;
      Estrategia_Robos_E1 [2].Posicao.Y := 250;
      Estrategia_Robos_E1 [2].Angulo    := 0;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 200;
      Estrategia_Robos_E1 [3].Posicao.Y := 650;
      Estrategia_Robos_E1 [3].Angulo    := 0;
      Estrategia_Robos_E1 [3].Veloc     := 0;
    End;
    TiroMeta_E1:
    Begin

      Estrategia_Robos_E1 [1].Posicao.X := 80;
      Estrategia_Robos_E1 [1].Posicao.Y := 450;
      Estrategia_Robos_E1 [1].Angulo    := 0;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 500;
      Estrategia_Robos_E1 [2].Posicao.Y := 350;
      Estrategia_Robos_E1 [2].Angulo    := 0;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 800;
      Estrategia_Robos_E1 [3].Posicao.Y := 750;
      Estrategia_Robos_E1 [3].Angulo    := 0;
      Estrategia_Robos_E1 [3].Veloc     := 0;
    End;
    TiroMeta_E2:
    Begin

      Estrategia_Robos_E1 [1].Posicao.X := 80;
      Estrategia_Robos_E1 [1].Posicao.Y := 450;
      Estrategia_Robos_E1 [1].Angulo    := 0;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 500;
      Estrategia_Robos_E1 [2].Posicao.Y := 350;
      Estrategia_Robos_E1 [2].Angulo    := 0;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 400;
      Estrategia_Robos_E1 [3].Posicao.Y := 550;
      Estrategia_Robos_E1 [3].Angulo    := 0;
      Estrategia_Robos_E1 [3].Veloc     := 0;
    End;
    Penalti_E1:
    Begin

      Estrategia_Robos_E1 [1].Posicao.X := 80;
      Estrategia_Robos_E1 [1].Posicao.Y := 450;
      Estrategia_Robos_E1 [1].Angulo    := 0;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 600;
      Estrategia_Robos_E1 [2].Posicao.Y := 350;
      Estrategia_Robos_E1 [2].Angulo    := 0;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 800;
      Estrategia_Robos_E1 [3].Posicao.Y := 450;
      Estrategia_Robos_E1 [3].Angulo    := 0;
      Estrategia_Robos_E1 [3].Veloc     := 0;
    End;
    Penalti_E2:
    Begin

      Estrategia_Robos_E1 [1].Posicao.X := 80;
      Estrategia_Robos_E1 [1].Posicao.Y := 450;
      Estrategia_Robos_E1 [1].Angulo    := 0;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      estrategia_Robos_E1 [2].Posicao.X := 700;
      Estrategia_Robos_E1 [2].Posicao.Y := 350;
      Estrategia_Robos_E1 [2].Angulo    := 325;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 700;
      Estrategia_Robos_E1 [3].Posicao.Y := 650;
      Estrategia_Robos_E1 [3].Angulo    := 10;
      Estrategia_Robos_E1 [3].Veloc     := 0;
    End;
    Bola_Alto_P:
    Begin

      Estrategia_Robos_E1 [1].Posicao.X := -45;
      Estrategia_Robos_E1 [1].Posicao.Y := 383;
      Estrategia_Robos_E1 [1].Angulo    := 325;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 200;
      Estrategia_Robos_E1 [2].Posicao.Y := 250;
      Estrategia_Robos_E1 [2].Angulo    := 0;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 400;
      Estrategia_Robos_E1 [3].Posicao.Y := 550;
      Estrategia_Robos_E1 [3].Angulo    := 0;
      Estrategia_Robos_E1 [3].Veloc     := 0;


    End;
    Bola_Alto_Q:
    Begin

      Estrategia_Robos_E1 [1].Posicao.X := -45;
      Estrategia_Robos_E1 [1].Posicao.Y := 383;
      Estrategia_Robos_E1 [1].Angulo    := 325;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 200;
      Estrategia_Robos_E1 [2].Posicao.Y := 650;
      Estrategia_Robos_E1 [2].Angulo    := 0;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 400;
      Estrategia_Robos_E1 [3].Posicao.Y := 350;
      Estrategia_Robos_E1 [3].Angulo    := 10;
      Estrategia_Robos_E1 [3].Veloc     := 0;


    End;
    Bola_Alto_R:
    Begin

      Estrategia_Robos_E1 [1].Posicao.X := -45;
      Estrategia_Robos_E1 [1].Posicao.Y := 383;
      Estrategia_Robos_E1 [1].Angulo    := 325;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 600;
      Estrategia_Robos_E1 [2].Posicao.Y := 450;
      Estrategia_Robos_E1 [2].Angulo    := 0;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 700;
      Estrategia_Robos_E1 [3].Posicao.Y := 250;
      Estrategia_Robos_E1 [3].Angulo    := 0;
      Estrategia_Robos_E1 [3].Veloc     := 0;


    End;
    Bola_Alto_S:
    Begin

      Estrategia_Robos_E1 [1].Posicao.X := -45;
      Estrategia_Robos_E1 [1].Posicao.Y := 383;
      Estrategia_Robos_E1 [1].Angulo    := 325;
      Estrategia_Robos_E1 [1].Veloc     := 0;

      Estrategia_Robos_E1 [2].Posicao.X := 600;
      Estrategia_Robos_E1 [2].Posicao.Y := 450;
      Estrategia_Robos_E1 [2].Angulo    := 0;
      Estrategia_Robos_E1 [2].Veloc     := 0;

      Estrategia_Robos_E1 [3].Posicao.X := 700;
      Estrategia_Robos_E1 [3].Posicao.Y := 650;
      Estrategia_Robos_E1 [3].Angulo    := 0;
      Estrategia_Robos_E1 [3].Veloc     := 0;


    End;
  End;
End; {Procedure}




Exports
Acoes_Robos Index 1;

Begin
End.



