Library Dll2;

Uses
  SysUtils,
  Classes;

Const
     Comprimento_Gol               =      100; { Milmetros (rea interna do gol) }
     Comprimento_Campo             =     1300; { Milmetros }
     Largura_Campo                 =      900; { Milmetros }
     Velocidade_Linear_Limite      =     5000; { Milmetros/s }
     Velocidade_Linear_Re_Limite   =    -5000; { Milmetros/s }
     Total_Robos_por_Equipe        =        3;
     Lado_Robo                     =       75; { Milmetros/s }
     Raio_Bola                     =       20;
Type
   TGraus       = 0..360   ;
   TComprimento = -Comprimento_Gol..(Comprimento_Campo + Comprimento_Gol);
   TLargura     = 0..Largura_Campo                                       ;
   TVelocidade  = Velocidade_Linear_Re_Limite..Velocidade_Linear_Limite  ;

   TOcorrencia = (Inicio_Jogo  ,
                  Reinicio_Jogo,
                  Gol_E1       ,
                  Gol_E2       ,
                  Falta_E1     ,
                  Falta_E2     ,
                  Penalti_E1   ,
                  Penalti_E2   ,
                  TiroMeta_E1  ,
                  TiroMeta_E2  ,
                  Bola_Alto_P  ,
                  Bola_Alto_Q  ,
                  Bola_Alto_R  ,
                  Bola_Alto_S  ,
                  Jogo_em_Andamento,
                  Pausa_Simulador  );

   TPosicao = Record
      X: TComprimento;
      Y: TLargura    ;
   End;

   TInformacoes_Robo = Record
      Angulo : TGraus     ;
      Veloc  : TVelocidade;
      Posicao: TPosicao   ;
   End;

   TInformacoes_Robos = Array [1..Total_Robos_por_Equipe] of TInformacoes_Robo;

   TInformacoes_Bola = Record
      Angulo : TGraus     ;
      Veloc  : TVelocidade;
      Posicao: TPosicao   ;
   End;

Procedure Acoes_Robos (Var Estrategia_Robos_E2    : TInformacoes_Robos;
                           Informacoes_Robos_E1   : TInformacoes_Robos;
                           Informacoes_Robos_E2   : TInformacoes_Robos;
                           Informacoes_Bola       : TInformacoes_Bola ;
                           Ocorrencia             : TOcorrencia);
Begin

     Case Ocorrencia Of
        Falta_E1:
        Begin
          Estrategia_Robos_E2 [1].Posicao.X := 1242;
          Estrategia_Robos_E2 [1].Posicao.Y := 450;
          Estrategia_Robos_E2 [1].Angulo    := 180;
          Estrategia_Robos_E2 [1].Veloc     := 0;

          Estrategia_Robos_E2 [2].Posicao.X := 1100;
          Estrategia_Robos_E2 [2].Posicao.Y := 250;
          Estrategia_Robos_E2 [2].Angulo    := 180;
          Estrategia_Robos_E2 [2].Veloc     := 0;

          Estrategia_Robos_E2 [3].Posicao.X := 1100;
          Estrategia_Robos_E2 [3].Posicao.Y := 650;
          Estrategia_Robos_E2 [3].Angulo    := 180;
          Estrategia_Robos_E2 [3].Veloc     := 0;
        End;
        Falta_E2:
        Begin
          Estrategia_Robos_E2 [1].Posicao.X := 1242;
          Estrategia_Robos_E2 [1].Posicao.Y := 450;
          Estrategia_Robos_E2 [1].Angulo    := 180;
          Estrategia_Robos_E2 [1].Veloc     := 0;

          Estrategia_Robos_E2 [2].Posicao.X := 600;
          Estrategia_Robos_E2 [2].Posicao.Y := 450;
          Estrategia_Robos_E2 [2].Angulo    := 180;
          Estrategia_Robos_E2 [2].Veloc     := 0;

          Estrategia_Robos_E2 [3].Posicao.X := 600;
          Estrategia_Robos_E2 [3].Posicao.Y := 650;
          Estrategia_Robos_E2 [3].Angulo    := 180;
          Estrategia_Robos_E2 [3].Veloc     := 0;
        End;
        Bola_Alto_P:
           Begin
              Estrategia_Robos_E2 [1].Posicao.X := 1242;
              Estrategia_Robos_E2 [1].Posicao.Y := 450;
              Estrategia_Robos_E2 [1].Angulo    := 90;
              Estrategia_Robos_E2 [1].Veloc     := 0;

              Estrategia_Robos_E2 [2].Posicao.X := 600;
              Estrategia_Robos_E2 [2].Posicao.Y := 250;
              Estrategia_Robos_E2 [2].Angulo    := 180;
              Estrategia_Robos_E2 [2].Veloc     := 0;

              Estrategia_Robos_E2 [3].Posicao.X := 700;
              Estrategia_Robos_E2 [3].Posicao.Y := 450;
              Estrategia_Robos_E2 [3].Angulo    := 180;
              Estrategia_Robos_E2 [3].Veloc     := 0;
           End;
        Bola_Alto_Q:
           Begin
              Estrategia_Robos_E2 [1].Posicao.X := 1242;
              Estrategia_Robos_E2 [1].Posicao.Y := 450;
              Estrategia_Robos_E2 [1].Angulo    := 90;
              Estrategia_Robos_E2 [1].Veloc     := 0;

              Estrategia_Robos_E2 [2].Posicao.X := 600;
              Estrategia_Robos_E2 [2].Posicao.Y := 650;
              Estrategia_Robos_E2 [2].Angulo    := 180;
              Estrategia_Robos_E2 [2].Veloc     := 0;

              Estrategia_Robos_E2 [3].Posicao.X := 700;
              Estrategia_Robos_E2 [3].Posicao.Y := 450;
              Estrategia_Robos_E2 [3].Angulo    := 180;
              Estrategia_Robos_E2 [3].Veloc     := 0;
           End;
           Bola_Alto_R:
           Begin
              Estrategia_Robos_E2 [1].Posicao.X := 1242;
              Estrategia_Robos_E2 [1].Posicao.Y := 450;
              Estrategia_Robos_E2 [1].Angulo    := 90;
              Estrategia_Robos_E2 [1].Veloc     := 0;

              Estrategia_Robos_E2 [2].Posicao.X := 1100;
              Estrategia_Robos_E2 [2].Posicao.Y := 250;
              Estrategia_Robos_E2 [2].Angulo    := 180;
              Estrategia_Robos_E2 [2].Veloc     := 0;

              Estrategia_Robos_E2 [3].Posicao.X := 900;
              Estrategia_Robos_E2 [3].Posicao.Y := 550;
              Estrategia_Robos_E2 [3].Angulo    := 180;
              Estrategia_Robos_E2 [3].Veloc     := 0;
           End;
           Bola_Alto_S:
           Begin
              Estrategia_Robos_E2 [1].Posicao.X := 1242;
              Estrategia_Robos_E2 [1].Posicao.Y := 450;
              Estrategia_Robos_E2 [1].Angulo    := 90;
              Estrategia_Robos_E2 [1].Veloc     := 0;

              Estrategia_Robos_E2 [2].Posicao.X := 1100;
              Estrategia_Robos_E2 [2].Posicao.Y := 650;
              Estrategia_Robos_E2 [2].Angulo    := 180;
              Estrategia_Robos_E2 [2].Veloc     := 0;

              Estrategia_Robos_E2 [3].Posicao.X := 900;
              Estrategia_Robos_E2 [3].Posicao.Y := 350;
              Estrategia_Robos_E2 [3].Angulo    := 180;
              Estrategia_Robos_E2 [3].Veloc     := 0;
           End;
           Inicio_Jogo:
           Begin
              Estrategia_Robos_E2 [1].Posicao.X := 1242;
              Estrategia_Robos_E2 [1].Posicao.Y := 450;
              Estrategia_Robos_E2 [1].Angulo    := 90;
              Estrategia_Robos_E2 [1].Veloc     := 0;

              Estrategia_Robos_E2 [2].Posicao.X := 802;
              Estrategia_Robos_E2 [2].Posicao.Y := 450;
              Estrategia_Robos_E2 [2].Angulo    := 270;
              Estrategia_Robos_E2 [2].Veloc     := 0;

              Estrategia_Robos_E2 [3].Posicao.X := 1102;
              Estrategia_Robos_E2 [3].Posicao.Y := 225;
              Estrategia_Robos_E2 [3].Angulo    := 90;
              Estrategia_Robos_E2 [3].Veloc     := 0;
           End;

        Gol_E1:
           Begin
             Estrategia_Robos_E2 [1].Posicao.X := 1242;
              Estrategia_Robos_E2 [1].Posicao.Y := 450;
              Estrategia_Robos_E2 [1].Angulo    := 90;
              Estrategia_Robos_E2 [1].Veloc     := 0;

              Estrategia_Robos_E2 [2].Posicao.X := 802;
              Estrategia_Robos_E2 [2].Posicao.Y := 450;
              Estrategia_Robos_E2 [2].Angulo    := 270;
              Estrategia_Robos_E2 [2].Veloc     := 0;

              Estrategia_Robos_E2 [3].Posicao.X := 1102;
              Estrategia_Robos_E2 [3].Posicao.Y := 225;
              Estrategia_Robos_E2 [3].Angulo    := 90;
              Estrategia_Robos_E2 [3].Veloc     := 0;
           End;
        Gol_E2:
           Begin
             Estrategia_Robos_E2 [1].Posicao.X := 1242;
              Estrategia_Robos_E2 [1].Posicao.Y := 450;
              Estrategia_Robos_E2 [1].Angulo    := 90;
              Estrategia_Robos_E2 [1].Veloc     := 0;

              Estrategia_Robos_E2 [2].Posicao.X := 802;
              Estrategia_Robos_E2 [2].Posicao.Y := 450;
              Estrategia_Robos_E2 [2].Angulo    := 270;
              Estrategia_Robos_E2 [2].Veloc     := 0;

              Estrategia_Robos_E2 [3].Posicao.X := 1102;
              Estrategia_Robos_E2 [3].Posicao.Y := 225;
              Estrategia_Robos_E2 [3].Angulo    := 90;
              Estrategia_Robos_E2 [3].Veloc     := 0;
           End;
        TiroMeta_E2:
           Begin

             Estrategia_Robos_E2 [1].Posicao.X := 1220;
             Estrategia_Robos_E2 [1].Posicao.Y := 450;
             Estrategia_Robos_E2 [1].Angulo    := 180;
             Estrategia_Robos_E2 [1].Veloc     := 0;

             Estrategia_Robos_E2 [2].Posicao.X := 500;
             Estrategia_Robos_E2 [2].Posicao.Y := 150;
             Estrategia_Robos_E2 [2].Angulo    := 180;
             Estrategia_Robos_E2 [2].Veloc     := 0;

             Estrategia_Robos_E2 [3].Posicao.X := 800;
             Estrategia_Robos_E2 [3].Posicao.Y := 550;
             Estrategia_Robos_E2 [3].Angulo    := 180;
             Estrategia_Robos_E2 [3].Veloc     := 0;
           End;
    TiroMeta_E1:
    Begin

      Estrategia_Robos_E2 [1].Posicao.X := 1220;
      Estrategia_Robos_E2 [1].Posicao.Y := 450;
      Estrategia_Robos_E2 [1].Angulo    := 180;
      Estrategia_Robos_E2 [1].Veloc     := 0;

      Estrategia_Robos_E2 [2].Posicao.X := 800;
      Estrategia_Robos_E2 [2].Posicao.Y := 350;
      Estrategia_Robos_E2 [2].Angulo    := 180;
      Estrategia_Robos_E2 [2].Veloc     := 0;

      Estrategia_Robos_E2 [3].Posicao.X := 900;
      Estrategia_Robos_E2 [3].Posicao.Y := 550;
      Estrategia_Robos_E2 [3].Angulo    := 180;
      Estrategia_Robos_E2 [3].Veloc     := 0;
    End;
    Penalti_E2:
    Begin

      Estrategia_Robos_E2 [1].Posicao.X := 1220;
      Estrategia_Robos_E2 [1].Posicao.Y := 450;
      Estrategia_Robos_E2 [1].Angulo    := 180;
      Estrategia_Robos_E2 [1].Veloc     := 0;

      Estrategia_Robos_E2 [2].Posicao.X := 500;
      Estrategia_Robos_E2 [2].Posicao.Y := 450;
      Estrategia_Robos_E2 [2].Angulo    := 180;
      Estrategia_Robos_E2 [2].Veloc     := 0;

      Estrategia_Robos_E2 [3].Posicao.X := 900;
      Estrategia_Robos_E2 [3].Posicao.Y := 550;
      Estrategia_Robos_E2 [3].Angulo    := 180;
      Estrategia_Robos_E2 [3].Veloc     := 0;
    End;
    Penalti_E1:
    Begin

      Estrategia_Robos_E2 [1].Posicao.X := 1220;
      Estrategia_Robos_E2 [1].Posicao.Y := 450;
      Estrategia_Robos_E2 [1].Angulo    := 180;
      Estrategia_Robos_E2 [1].Veloc     := 0;

      Estrategia_Robos_E2 [2].Posicao.X := 450;
      Estrategia_Robos_E2 [2].Posicao.Y := 650;
      Estrategia_Robos_E2 [2].Angulo    := 325;
      Estrategia_Robos_E2 [2].Veloc     := 0;

      Estrategia_Robos_E2 [3].Posicao.X := 700;
      Estrategia_Robos_E2 [3].Posicao.Y := 550;
      Estrategia_Robos_E2 [3].Angulo    := 10;
      Estrategia_Robos_E2 [3].Veloc     := 0;


    End;

        Jogo_em_Andamento:
        Begin
          Estrategia_Robos_E2[1].Veloc :=2000;
          Estrategia_Robos_E2[1].Angulo:= 180;
        End
     End; {case}
  End; {Procedure}


Exports
   Acoes_Robos Index 1;

Begin
End.
